from nosuch.midiutil import *
from nosuch.midifile import *
from traceback import format_exc
from time import sleep
import sys

if __name__ == '__main__':

	if len(sys.argv) < 3:
		print "Usage: midiplay {filename} {outputdevice}"
		sys.exit(1)

	fname = sys.argv[1]
	outname = sys.argv[2]

	o = MidiOutput(outname)
	Midi.startup()

	# If you want to get debug output (e.g. to see when
	# things are written to MIDI output), use this:
	# Midi.debug = True

	# Read the midifile
	p = Phrase.fromMidiFile(fname)

	# Open MIDI output named
	try:
		o = MidiOutput(outname)
		o.open()
	except:
		print "Error opening output: ",outname
		Midi.shutdown()
		sys.exit(1)

	# Schedule the notes of the midifile on the output
	for n in p:
		o.schedule(n)

	# sleep/wait till all the notes are played
	try:
		while len(Midi.scheduled()) > 0:
			sleep(1.0)
	except KeyboardInterrupt:
		print "Got KeyboardInterrupt!"
	except:
		print "Unexpected exception: %s" % format_exc()

	Midi.shutdown()
